// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

import java.net.*;
import java.io.*;
import java.lang.*;

class FileConverter
{

	static public byte[] readFile(String filePath)
	{
		byte[] fileByteArray = null;

		if(!filePath.equals(""))
		{

			//Open the file and read data from it
			DataInputStream inputFile = null;
			ByteArrayOutputStream baos = null;

			try {

				inputFile = new DataInputStream( new FileInputStream(filePath));
			}
			catch(IOException f)
			{
				System.out.println("Error Opening File\n");
			}
			try{
				fileByteArray = new byte[inputFile.available()];
				inputFile.readFully(fileByteArray);
			}
			catch(IOException f)
			{
				System.out.println("Error reading file\n");
			}

			baos = new ByteArrayOutputStream();
			baos.write(fileByteArray, 0, fileByteArray.length);
		}
		return fileByteArray;
	}

	static public String encodeBytes(byte[] buf)
	{
		String s = new sun.misc.BASE64Encoder().encode(buf);
		return s;
	}

	static public byte[] decodeString(String s)
	{
		byte[] buf = null;
		try
		{
			buf = new sun.misc.BASE64Decoder().decodeBuffer(s);

		}
		catch(IOException e) {}
		return buf;
	}

	static public void writeFile(byte[] picBytes, String path)
	{
	   DataOutputStream outputFile = null;

	   ByteArrayOutputStream baos = new ByteArrayOutputStream();
	   baos.write(picBytes, 0, picBytes.length);

	   try {
	      outputFile = new DataOutputStream( new FileOutputStream(path));
	   }
	   catch(IOException o)
	   {
		  System.out.println("Error Opening File");
	   }

	   try{
	      baos.writeTo(outputFile);
	   }
	   catch(IOException w)
	   {
		  System.out.println("Error writing to file");
	   }
	   try{
	      outputFile.close();
	   }
	   catch(IOException c)
	   {
	      System.out.println("Error closing file");
	   }


	}
}