// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class Post extends JPanel {

	boolean debug = false;

    JLabel lbl_Question;
    JLabel lbl_Choices;
    JLabel lbl_time;
    JLabel lbl_Type;
    JLabel lbl_Answer;
	JLabel lbl_No;
	JLabel lbl_TestNo;
	JLabel lbl_CourseNo;
	JLabel lbl_A;
    JLabel lbl_B;
    JLabel lbl_C;
    JLabel lbl_D;
    JLabel lbl_E;

	JTextArea txt_Question;
	JScrollPane QuestionScrollPane;

    JTextField txt_Choice0;
    JTextField txt_Choice1;
    JTextField txt_Choice2;
    JTextField txt_Choice3;
    JTextField txt_Choice4;
    JTextField txt_No;
	JTextField txt_TestNo;
	JTextField txt_CourseNo;
    JTextField txt_ShortAnswer;

    JButton btn_Clear;
    JButton btn_Submit;

    JButton btn_AttachPic;


	JComboBox combo_Time;
	JComboBox combo_Answer;

	ButtonGroup cbg;
	JRadioButton radio_SA;
	JRadioButton radio_TF;
    JRadioButton radio_MC;

	Question newQuestion;

    public Post() {
        PostLayout customLayout = new PostLayout();

		newQuestion = new Question();

		setLayout(customLayout);

        lbl_Question = new JLabel("Question:");
		add(lbl_Question);  //c0

        combo_Time = new JComboBox();
		combo_Time.setForeground(Color.blue);

		combo_Time.addItem("1");
        combo_Time.addItem("2");
        combo_Time.addItem("3");
        combo_Time.addItem("4");
        combo_Time.addItem("5");
        add(combo_Time);  //c1

        btn_Submit = new JButton("Submit");
		//btn_Submit.setEnabled(false);
        add(btn_Submit);  //c2

		txt_Question = new JTextArea();
		txt_Question.setFont(new Font("TimesRoman", Font.BOLD, 14));
		txt_Question.setForeground(Color.blue);

		QuestionScrollPane = new JScrollPane(txt_Question);
        add(QuestionScrollPane);  //c3

        txt_Choice0 = new JTextField("");
		txt_Choice0.setForeground(Color.blue);
        add(txt_Choice0);  //c4

        txt_Choice1 = new JTextField("");
		txt_Choice1.setForeground(Color.blue);
        add(txt_Choice1); //c5

        txt_Choice2 = new JTextField("");
		txt_Choice2.setForeground(Color.blue);
        add(txt_Choice2); //c6

        txt_Choice3 = new JTextField("");
		txt_Choice3.setForeground(Color.blue);
        add(txt_Choice3);  //c7

        lbl_Choices = new JLabel("Choices:");
        add(lbl_Choices);  //c8

        lbl_time = new JLabel("Time:");
        add(lbl_time);  //c9

        btn_Clear = new JButton("Clear");
        add(btn_Clear);  //c10

        txt_Choice4 = new JTextField("");
		txt_Choice4.setForeground(Color.blue);
        add(txt_Choice4);  //c11

        cbg = new ButtonGroup();
        radio_TF = new JRadioButton("True/False", false);
        cbg.add(radio_TF);
        add(radio_TF);  //c12

        radio_MC = new JRadioButton("Multiple Choice", false);
        cbg.add(radio_MC);
        add(radio_MC);  //c13

        lbl_Type = new JLabel("Type:");
        add(lbl_Type);  //c14

		combo_Answer = new JComboBox();
		combo_Answer.setForeground(Color.blue);
        combo_Answer.addItem("True");
        combo_Answer.addItem("False");
        combo_Answer.addItem("A");
        combo_Answer.addItem("B");
        combo_Answer.addItem("C");
        combo_Answer.addItem("D");
        combo_Answer.addItem("E");
        add(combo_Answer);  //c15

        lbl_Answer = new JLabel("Answer:");
        add(lbl_Answer);  //c16

		lbl_No = new JLabel("Question Num:");
        add(lbl_No);  //c17

        txt_No = new JTextField("");
		txt_No.setForeground(Color.blue);
        add(txt_No);  //c18

		lbl_CourseNo = new JLabel("Course Num:");
        add(lbl_CourseNo);  //c19

        txt_CourseNo = new JTextField("");
		txt_CourseNo.setForeground(Color.blue);
        txt_CourseNo.setEditable(false);
		add(txt_CourseNo);  //c20

		lbl_TestNo = new JLabel("Test Num:");
        add(lbl_TestNo);  //c21

        txt_TestNo = new JTextField("");
		txt_TestNo.setForeground(Color.blue);
        add(txt_TestNo);  //c22

		lbl_A = new JLabel("A:");
        add(lbl_A);  //c23

        lbl_B = new JLabel("B:");
        add(lbl_B);  //c24

        lbl_C = new JLabel("C:");
        add(lbl_C);  //c25

        lbl_D = new JLabel("D:");
        add(lbl_D);  //c26

        lbl_E = new JLabel("E:");
        add(lbl_E);  //c27

		radio_SA = new JRadioButton("Short Answer", false);
        cbg.add(radio_SA);
        add(radio_SA);  //c28

		txt_ShortAnswer = new JTextField("");
		txt_ShortAnswer.setForeground(Color.blue);
		add(txt_ShortAnswer);  //c29

		btn_AttachPic = new JButton("Attach Picture");
		add(btn_AttachPic);   //c30

		RadioButtonHandler rdb_handler = new RadioButtonHandler();
		radio_TF.addItemListener(rdb_handler);
		radio_MC.addItemListener(rdb_handler);
		radio_SA.addItemListener(rdb_handler);

		ButtonHandler btn_handler = new ButtonHandler();
		btn_Clear.addActionListener(btn_handler);
		btn_Submit.addActionListener(btn_handler);
		btn_AttachPic.addActionListener(btn_handler);

		//setSize(getPreferredSize());
   }

	public void setCourseNo(String c)
	{
	   txt_CourseNo.setText(c);
	}

	public void Reset()
	{
		txt_Question.setText("");
		txt_Choice0.setText("");
		txt_Choice1.setText("");
		txt_Choice2.setText("");
		txt_Choice3.setText("");
		txt_Choice4.setText("");
		txt_ShortAnswer.setText("");
	}

	//inner class for radio button event handling
	private class RadioButtonHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e)
		{
			if(e.getSource()==radio_MC)
			{
				newQuestion.setType("0");
			}
			else if (e.getSource()==radio_TF)
			{
				newQuestion.setType("1");
			}
			else if (e.getSource()==radio_SA)
			{
				newQuestion.setType("2");
			}
		}
	}

	//inner class for button event handling
	private class ButtonHandler implements ActionListener{
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource() == btn_Clear)
			{
				Reset(); //modified 4.2.05
				txt_No.setText("");
			}
			else if (e.getSource() == btn_AttachPic)
			{
				if(debug)
					System.out.println("Uploading picture ....\n");
				FileOpener fo = new FileOpener(newQuestion);
			}
			else if (e.getSource() == btn_Submit)
			{
				String choices[]={"","","","",""};

				if( newQuestion.getType().equals(""))
					JOptionPane.showMessageDialog(null,"Please select a question type","Error",JOptionPane.WARNING_MESSAGE);
				else if ( (newQuestion.getType().equals("2")) && (txt_ShortAnswer.getText()).equals("") )
					JOptionPane.showMessageDialog(null,"Please enter the short answer","Error",JOptionPane.WARNING_MESSAGE);
				else if( (txt_Question.getText()).equals(""))
					JOptionPane.showMessageDialog(null,"Please enter the question","Error",JOptionPane.WARNING_MESSAGE);
				else if( (txt_No.getText()).equals(""))
					JOptionPane.showMessageDialog(null,"Please enter the question number","Error",JOptionPane.WARNING_MESSAGE);
				else if( (txt_TestNo.getText()).equals(""))
					JOptionPane.showMessageDialog(null,"Please enter the test number","Error",JOptionPane.WARNING_MESSAGE);
				else
				{
					if(!Global.startedTest)
					{
						newQuestion.setNumber(txt_No.getText());
						newQuestion.setTestNum(txt_TestNo.getText());
					}
					else
					{
						Global.quesNum = Global.nextQuesNum;
						newQuestion.setNumber(Global.quesNum);
						newQuestion.setTestNum(Global.testNum);
					}

					newQuestion.setQuestion(txt_Question.getText());
					if( (choices[0]=txt_Choice0.getText()).equals(""))
						choices[0]="null";
					if( (choices[1]=txt_Choice1.getText()).equals(""))
						choices[1]="null";
					if( (choices[2]=txt_Choice2.getText()).equals(""))
						choices[2]="null";
					if( (choices[3]=txt_Choice3.getText()).equals(""))
						choices[3]="null";
					if( (choices[4]=txt_Choice4.getText()).equals(""))
						choices[4]="null";

					newQuestion.setTime(combo_Time.getSelectedIndex());
					newQuestion.setAnswer(combo_Answer.getSelectedIndex());
					newQuestion.setShortAnswer(txt_ShortAnswer.getText());

					newQuestion.setChoices(choices);

					if(PrintQuestion())
					{
						submitQuestion();
						Reset();  //modified 4.2.05
					}
				}
			}
		}
	}

	public boolean PrintQuestion()
	{
		String choice[] = newQuestion.getChoices();
		String type;
		if( (newQuestion.getType()).equals("0"))
			type="Multiple Choice";
		else if ( (newQuestion.getType()).equals("1"))
			type="True/False";
		else
			type="Short Answer";

		String msg =
			"Test Num: "+newQuestion.getTestNum()+"\n"+
			"Question Num: "+newQuestion.getNumber()+"\n"+
			"Type: "+type+"\n"+
			"Question: "+newQuestion.getQuestion()+"\n";
		if(newQuestion.getType().equals("0"))
		{
			msg+="Choices:\n  "+choice[0]+"\n  "+choice[1]+"\n  "+choice[2]+"\n  "+choice[3]+"\n  "
						+choice[4]+"\n  "+choice[5]+"\n";
		}
		msg+="Time: "+newQuestion.getTime()+"\n";
		if( (newQuestion.getType()).equals("2"))
		    msg+="Short Answer: "+newQuestion.getShortAnswer();
		else
			msg+="Answer: "+newQuestion.getAnswer();

		int answer;
		answer=JOptionPane.showConfirmDialog(null, msg, "Is this question correct?", JOptionPane.YES_NO_OPTION);

		if(answer==0)
			return true;
		else
			return false;
	}

	public void submitQuestion()
	{
		newQuestion.submitQuestion();
	}

	public void init()
	{
		Reset();
		txt_TestNo.setText("");
		txt_No.setText("");
		txt_TestNo.setEditable(true);
		txt_No.setEditable(true);
	}

	public void startNewQuestion()
	{
		newQuestion=new Question();
	}
	public void enablePanel()
	{
		txt_TestNo.setEnabled(true);
		txt_No.setEnabled(true);

		if(Global.startedTest)
		{
			txt_TestNo.setText(Global.testNum);
		    txt_No.setText(Global.nextQuesNum);

			txt_TestNo.setEditable(false);
			txt_No.setEditable(false);
		}

		txt_Question.setEnabled(true);
		txt_Choice0.setEnabled(true);
		txt_Choice1.setEnabled(true);
		txt_Choice2.setEnabled(true);
		txt_Choice3.setEnabled(true);
		txt_Choice4.setEnabled(true);
		txt_ShortAnswer.setEnabled(true);
		combo_Time.setEnabled(true);
		combo_Answer.setEnabled(true);
		btn_Submit.setEnabled(true);
		btn_Clear.setEnabled(true);
		btn_AttachPic.setEnabled(true);
		radio_MC.setEnabled(true);
		radio_TF.setEnabled(true);
		radio_SA.setEnabled(true);
	}
	public void disablePanel()
	{
		txt_No.setEnabled(false);
		txt_TestNo.setEnabled(false);
		txt_Question.setEnabled(false);
		txt_Choice0.setEnabled(false);
		txt_Choice1.setEnabled(false);
		txt_Choice2.setEnabled(false);
		txt_Choice3.setEnabled(false);
		txt_Choice4.setEnabled(false);
		txt_ShortAnswer.setEnabled(false);
		combo_Time.setEnabled(false);
		combo_Answer.setEnabled(false);
		btn_Submit.setEnabled(false);
		btn_Clear.setEnabled(false);
		btn_AttachPic.setEnabled(false);
		radio_MC.setEnabled(false);
		radio_TF.setEnabled(false);
		radio_SA.setEnabled(false);
	}
}

class PostLayout implements LayoutManager {

    public PostLayout() {
    }

    public void addLayoutComponent(String name, Component comp) {
    }

    public void removeLayoutComponent(Component comp) {
    }

    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        Insets insets = parent.getInsets();
        dim.width = 365 + insets.left + insets.right;
        dim.height = 365 + insets.top + insets.bottom;

        return dim;
    }

    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);
        return dim;
    }

    public void layoutContainer(Container parent) {
        Insets insets = parent.getInsets();
		Component c;

		c = parent.getComponent(0);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+46,96,24);}
        c = parent.getComponent(1);
        if (c.isVisible()) {c.setBounds(insets.left+50,insets.top+348,72,24);}
        c = parent.getComponent(2);
        if (c.isVisible()) {c.setBounds(insets.left+222,insets.top+348,80,24);}
        c = parent.getComponent(3);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+70,270,60);}
        c = parent.getComponent(4);
        if (c.isVisible()) {c.setBounds(insets.left+160,insets.top+152,130,24);}
        c = parent.getComponent(5);
        if (c.isVisible()) {c.setBounds(insets.left+160,insets.top+184,130,24);}
        c = parent.getComponent(6);
        if (c.isVisible()) {c.setBounds(insets.left+160,insets.top+216,130,24);}
        c = parent.getComponent(7);
        if (c.isVisible()) {c.setBounds(insets.left+160,insets.top+248,130,24);}
        c = parent.getComponent(8);
        if (c.isVisible()) {c.setBounds(insets.left+138,insets.top+128,96,24);}
        c = parent.getComponent(9);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+348,80,24);}
        c = parent.getComponent(10);
        if (c.isVisible()) {c.setBounds(insets.left+132,insets.top+348,80,24);}
        c = parent.getComponent(11);
        if (c.isVisible()) {c.setBounds(insets.left+160,insets.top+280,130,24);}
        c = parent.getComponent(12);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+176,120,24);}
        c = parent.getComponent(13);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+152,120,24);}
        c = parent.getComponent(14);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+128,72,24);}
        c = parent.getComponent(15);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+252,72,24);}
        c = parent.getComponent(16);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+228,72,24);}
        c = parent.getComponent(17);
        if (c.isVisible()) {c.setBounds(insets.left+158,insets.top+46,96,24);}
        c = parent.getComponent(18);
        if (c.isVisible()) {c.setBounds(insets.left+244,insets.top+46,32,24);}
        c = parent.getComponent(19);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+10,96,24);}
        c = parent.getComponent(20);
        if (c.isVisible()) {c.setBounds(insets.left+80,insets.top+10,48,24);}
        c = parent.getComponent(21);
        if (c.isVisible()) {c.setBounds(insets.left+158,insets.top+10,96,24);}
        c = parent.getComponent(22);
        if (c.isVisible()) {c.setBounds(insets.left+244,insets.top+10,32,24);}
        c = parent.getComponent(23);
        if (c.isVisible()) {c.setBounds(insets.left+138,insets.top+152,24,24);}
        c = parent.getComponent(24);
        if (c.isVisible()) {c.setBounds(insets.left+138,insets.top+184,24,24);}
        c = parent.getComponent(25);
        if (c.isVisible()) {c.setBounds(insets.left+138,insets.top+216,24,24);}
        c = parent.getComponent(26);
        if (c.isVisible()) {c.setBounds(insets.left+138,insets.top+248,24,24);}
        c = parent.getComponent(27);
        if (c.isVisible()) {c.setBounds(insets.left+138,insets.top+280,24,24);}
		c = parent.getComponent(28);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+200,120,24);}
		c = parent.getComponent(29);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+286,120,40);}
		c = parent.getComponent(30);
        if (c.isVisible()) {c.setBounds(insets.left+160,insets.top+312,130,24);}
    }
}
