// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 3.31.05
//--------------------------------------------------------------------------

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/* XMLFilter.java is used by XMLParser.java */
public class XMLFilter extends FileFilter {

    //Accept all directories and all .xml files.
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = Utils.getExtension(f);
        if (extension != null) {
            if (extension.equals("xml"))
                    return true;
            else
                return false;
        }

        return false;
    }

    //The description of this filter
    public String getDescription() {
        return "XML Files";
    }
}
