// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

class Answer
{
	private String testNum="", questNum="";
	private String fName="", lName="";
	private String answer="", shortAnswer="";
	private String type;  //0=MC/TF, 1=SA

	public Answer() {
	}

	public String getFname() { return fName; }
	public String getLname() { return lName; }
	public String getAnswer() { return answer; }
	public String getShortAnswer() {return shortAnswer; }
	public String getType() { return type; }

	public void resetAnswer()
	{
		answer="";
		shortAnswer="";
	}
	public void setFname(String fn) { fName=fn; }
	public void setLname(String ln) { lName=ln; }
	public void setAnswer(int i)
	{
		String index[]={"T","F","A","B","C","D","E"};
		answer=index[i];
	}
	public void setShortAnswer(String a) { shortAnswer=a; }
	public void setType(String t) { type=t;}

	/* Method to convert IncomingMessage into Answer object */
	public void loadAnswer(IncomingMessage msg)
	{
		fName=msg.getFirstName();
		lName=msg.getLastName();

		testNum=msg.getNextVariable();
		questNum=msg.getNextVariable();
		type=msg.getNextVariable();

		if (type.equals("0"))
			answer=msg.getNextVariable();
		else
			shortAnswer=msg.getNextVariable();
	}

	/* Method to convert Answer object into OutgoingMessage object */
	public void submitAnswer()
	{
	   OutgoingMessage msg = new OutgoingMessage(StaticFunctions.COMMAND_ANSWER);

	   msg.append( Global.testNum );
	   msg.append( Global.quesNum );
	   msg.append( type );

	   if(type.equals("0"))
		   msg.append( answer );
	   else
		   msg.append( shortAnswer );

	   //Send this message
	   Global.virtualClassroomThread.virtualClassroomSend(msg);
	}
}