// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class StatusMenu extends JPanel
{
   JLabel privateMsg = null;
   JLabel lastMsg = null;
   JLabel push = null;
   JLabel teacherOnly = null;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public StatusMenu()
   {
      super( new GridLayout( 1, 3, 5, 0 ) );

      privateMsg = new JLabel( "Private Message: On" );

      lastMsg = new JLabel( "Last Msg by: " );

      push = new JLabel( "Push Permission: On" );

      teacherOnly = new JLabel( "Teacher Only Push: Off" );

      add( privateMsg );

      add( lastMsg );

      add( push );

      add( teacherOnly );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void setPrivateItem( boolean b )
   {

      // message is true if DISABLED
      // map true to false (disable) and false to true(enable)
      if( b == !true )
         privateMsg.setText( "Private Message: On" );
      else
         privateMsg.setText( "Private Message: Off" );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void setLastMsgItem( String update )
   {
      lastMsg.setText( "Last Msg by: " + update );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void setPushItem( boolean b )
   {
      if( b == true )
         push.setText( "Push Permission: On" );
      else
         push.setText( "Push Permission: Off" );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void setTeacherItem( boolean b )
   {
      if( b == true )
         teacherOnly.setText( "Teacher Only Push: On" );
      else
         teacherOnly.setText( "Teacher Only Push: Off" );
   }
}